UNIT Global;

INTERFACE

USES Crt,ScrLib,Dos,OwlAsm,Utility,Graph;

CONST
     HabitatWidth  : Integer = 10;
     HabitatLength : Integer = 10;
     MaxOwls                 = 4000;
     LandScapeClasses        = 6;
     OwlClasses              = 3; {actually 1 more for settled males, but}
     ZoomXStart : Integer    = 1; {these classes are not displayed}
     ZoomYStart : Integer    = 1;
     OwlFlag                 = -8888;
     ClassFlag               = -9999;
     GlobalDelay : Word      = 20;
     GraphOn     : Boolean   = FALSE;
     MaxYears                = 500;
     MaxDeltaT               = 100;
     FledgeTotal   : Word    = 0;
     YrCtr         : Word    = 0;
     DeltaTCounter : Word    = 0;
     MaxStages               = 9;
     TotalYears    : Word    = 0;

{colors}
        Video1     : Byte = 7;       {30}
        Video2     : Byte = 7;       {31}
        HiVid      : Byte = 15;      {28}
        RevVid     : Byte = 112;     {112}
        RevVid2    : Byte = 112;     {63}
        ErrorVid   : Byte = 112;     {79}
        UnderVid   : Byte = 1;       {28}

    


TYPE
    HabitatRow     = Array[1..10] OF Byte;
    HabitatRowPtr  = ^HabitatRow;
    HabitatArr     = Array[1..500] OF HabitatRowPtr;
    CharSet        = Set OF Char;
    IndexType      = Array[1..MaxOwls] OF Word;
    TypeIndex      = Array[1..2] OF Word;
    DataArray      = Array[1..MaxYears] OF Word;
    RealDataArray  = Array[1..MaxYears] OF Single;
    OwlCtrType     = Array[0..MaxStages] OF Word;
    CtrType        = Array[0..MaxYears] OF ^OwlCtrType;
    TwoDDataArray  = Array[0..MaxStages] OF RealDataArray;
    BitArray       = Array[1..32] OF Word; { Compressed arr. }
                                           { holds up to 500 cells}
    WordArray      = Array[1..500] OF Word;{ Decompressed Arr.}
    HeaderInfo     = RECORD
                          X,Y,Years,Reps : Word;
                     END;
    DataPtr       = ^RealDataArray;
    Dimension     = RECORD
                       FY, LY, R1, R2, X1, X2, Y1, Y2 : Integer;
                    END;
   RowOcc       = Array[1..10] OF Single;
   RowOccPtr    = ^RowOcc;
   Occarr       = Array [1..500] OF RowOccPtr;


VAR
   Habitat                        : HabitatArr;
   OccMap                         : OccArr;
   ZoomXStop,ZoomYStop            : Integer;
   Totals                         : CtrType;
   PairStartCtr                   : DataArray;
   GenesLost                      : RealDataArray;
   GlobOutFileName,
   GlobInpFileName                : String;
   Header     : HeaderInfo;
   YearCt        : DataPtr;
   MeanArr,Std   : DataPtr;




{ These constants, types and variables from DYNAMICS}

CONST
     ReflectingBorder = 1;
     AbsorbingBorder  = 2;
     ContinuousBorder = 3;
     ReflectingType   = 16;  {Rock}
     SMale            = 1;
     SFemale          = 2;
     OwlPair          = 3;
     SettledMale      = 4;
    
TYPE
     SingleMale = RECORD
                         Row,Column         : Word;
                         Direction          : Byte;
                         Settled            : Boolean;
                         Allele1,Allele2    : Word;
                         StartX,StartY      : Word;
                         Age                : Byte;
                         EverPaired         : Boolean;
                     END;
    SingleFemale = RECORD
                           Row,Column      : Word;
                           Direction       : Byte;
                           Allele1,Allele2 : Word;
                           StartX,StartY   : Word;
                           Age             : Byte;
                           EverPaired      : Boolean;
                     END;
    
    Pair = RECORD
                 Row,Column         : Word;
                 Allele1,Allele2,
                 Allele3,Allele4    : Word;
                 MaleAge,FemaleAge  : Byte; {0 = j; 1 = SA; 2 = A}
           END;

    MaleArr     = Array[1..MaxOwls] OF SingleMale;
    FemaleArr   = Array[1..MaxOwls] OF SingleFemale;
    PairArr     = Array[1..MaxOwls] OF Pair;
    MalePtr     = ^MaleArr;
    FemalePtr   = ^FemaleArr;
    PairPtr     = ^PairArr;
    String4     = String[4];

    Population  = RECORD
                        MalePop                 : MalePtr;
                        FemalePop               : FemalePtr;                        
                        PairPop                 : PairPtr;
                        MaleCtr, FemaleCtr      : Word;
                        PairCtr                 : Word;
                    
                  END;

    LandTypeArr = Array[1..8] OF Byte;
    Distance = RECORD
                     SumDist : Single;
                     N       : LongInt;
               END;
VAR
   Owls                        : Population;
   MIndx,FIndx                 : IndexType;
   PairDistance,DeathDistance  : Distance;

PROCEDURE CenterText(Y,Att : Byte; St : String);
PROCEDURE HaltProgram;
PROCEDURE FatalErrors(Error : Byte);
PROCEDURE SlowWrite(x,y : Byte; St : String);
PROCEDURE HighlightWrite(X,Y,N,Att,HiAtt : Byte;St : String);
PROCEDURE ClearLine(Y : Byte);
PROCEDURE GetKeys(VAR Ch,ExtCh : Char);
FUNCTION ReturnYesNo : Char;
FUNCTION ReturnMenu(Chrs : CharSet) : Char;
PROCEDURE InputErrors(Low,High : Real; ErrorNo : Byte);
FUNCTION InputInteger(     X,Y,Field : Byte;
                           Low,High  : Integer;
                       VAR Value     : Integer) : Boolean;
PROCEDURE CreateHabitatArr(VAR Arr : HabitatArr);
PROCEDURE DestroyHabitatArr(VAR Arr : HabitatArr);
PROCEDURE SaveToFile(Flag : Integer;OwlFile,Menu : Boolean);
PROCEDURE InputFileName(    StartX,StartY,BackColor,
                            HiColor                     : Byte;
                            St                          : String;
                        VAR Inf                         : Text;
                        VAR EscSw                       : Boolean);
PROCEDURE OutputFileName(    StartX,StartY,BackColor,
                             HiColor                     : Byte;
                             St                          : String;
                         VAR Inf                         : Text;
                         VAR EscSw                       : Boolean);

FUNCTION InputText(     X,Y       : Byte;
                    VAR St        : String) : Boolean;
FUNCTION InputReal(        X,Y,Field,Decimals : Byte;
                           Low, High          : Real;
                       VAR Value              : Single) : Boolean;
FUNCTION InputExtended(        X,Y,Field,Decimals : Byte;
                               Low,High           : Single;
                           VAR Value              : Extended) : Boolean;
PROCEDURE SetColors;

IMPLEMENTATION
(****Error trapping procedures****)

PROCEDURE HaltProgram;
          BEGIN
               IF GraphOn THEN
                  CloseGraph;
               SetCursorSize(Cursor);
               NormVideo;
               ClrScr;
               Halt;
END;
PROCEDURE FatalErrors(Error : Byte);
BEGIN
     If GraphOn THEN RestoreCrtMode;
     WriteLn;
     CASE Error OF
          1 : WriteLn('Error - BGI file not found on the default drive');
          2 : WriteLn('Error - Insufficient memory to run program');
          3 : WriteLn('Error - Too many owls');
          4 : WriteLn('Error - Problem with map file read/write');
          5 : WriteLn('Error - Problem with file read/write');
          6 : WriteLn('Error - Problem with output header read/write');
          7 : WriteLn('Error - Problem with rules file read/write');
          8 : WriteLn('Error - Survival Variance is out of bounds');
          9 : WriteLn('Error - Fledge Variance is out of bounds');
     END;
     Write('Hit <Enter> to Exit Program');
     ReadLn;
     HaltProgram;
END;


(****I/O procedures, TextMode****)

PROCEDURE SlowWrite(x,y : Byte; St : String);
          BEGIN
               GoToXY(x,y);
               Write(St);
END;
PROCEDURE CenterText(Y,Att : Byte; St : String);
          VAR
             Posit : Word;
          BEGIN
               Posit := Pred(Y) * 160 + (80 - (Byte(St[0]) DIV 2) * 2);
               VarFWrite(Posit,Att,St);
END;
PROCEDURE HighlightWrite(X,Y,N,Att,HiAtt : Byte;St : String);
          VAR
             Posit : Word;
          BEGIN
               Posit := GetScrPos(X,Y);
               FastWrite(Posit,Att,St);
               Inc(Posit,Pred(N)*2);
               WriteChar(Posit,St[N],HiAtt);
END;
PROCEDURE ClearLine(Y : Byte);
          VAR
             Posit : Word;
          BEGIN
               Posit := Pred(Y) * 160;
               CharToScreen(Posit,80,' ',TextAttr);
END;
PROCEDURE GetKeys(VAR Ch,ExtCh : Char);
           BEGIN
                ExtCh := #0;
                Ch := ReadKey;
                IF Ch = #0 THEN
                   ExtCh := ReadKey;
END;
FUNCTION ReturnYesNo : Char;
         VAR
            Ch,Ch2 : Char;
         BEGIN
              REPEAT
                    GetKeys(Ch,Ch2);
                    Ch := UpCase(Ch);
              UNTIL Ch IN ['Y','N'];
              ReturnYesNo := Ch;
END;
FUNCTION ReturnMenu(Chrs : CharSet) : Char;
         VAR
            Ch,Ch2 : Char;
         BEGIN
              REPEAT
                    GetKeys(Ch,Ch2);
                    Ch := UpCase(Ch);
              UNTIL Ch IN Chrs;
              ReturnMenu := Ch;
END;


PROCEDURE InputErrors(Low,High : Real; ErrorNo : Byte);
          VAR
             Ch,Ch2      : Char;
             Temp1,Temp2 : String[20];
          BEGIN
               SetCursorSize(NoCursor);
               CASE ErrorNo OF
                   1 : CenterText(23,ErrorVid,'Error in Numeric Format');
                   2 : BEGIN
                           Str(Low:5:2,Temp1);
                           Str(High:5:2,Temp2);
                           CenterText(23,ErrorVid,'Error - Value out of Bounds');
                           CenterText(24,RevVid2,Temp1 + '  X  '+ Temp2);
                        END;
                    3 : CenterText(23,ErrorVid, 'File Not Found');
                    4 : CenterText(23,ErrorVid, 'Map Dimensions Wrong');
                    5 : CenterText(23,ErrorVid,'Error in File Read/Write');
                    6 : CenterText(23,ErrorVid,'Error in File Format');
                    7 : CenterText(23,ErrorVid,'Printer Error - Turn Printer On');
                    8 : CenterText(23,ErrorVid,'File Already Exists');
               END;
               CenterText(25,RevVid,'Hit Any Key to Continue, <ESC> to Quit');
               GetKeys(Ch,Ch2);
               IF Ch = #27 THEN HaltProgram;
               ClearLine(23);
               ClearLine(24);
               ClearLine(25);
               SetCursorSize(Cursor);
END;
PROCEDURE InputExtendedErrors(Low,High : Single; ErrorNo : Byte);
          VAR
             Ch,Ch2      : Char;
             Temp1,Temp2 : String[20];
          BEGIN
               SetCursorSize(NoCursor);
               CASE ErrorNo OF
                   1 : CenterText(23,ErrorVid,'Error in Numeric Format');
                   2 : BEGIN
                           Str(Low:15:2,Temp1);
                           Str(High:15:2,Temp2);
                           CenterText(23,ErrorVid,'Error - Value out of Bounds');
                           CenterText(24,RevVid2,Temp1 + '  X  '+ Temp2);
                        END;
               END;
               CenterText(25,RevVid,'Hit Any Key to Continue, <ESC> to Quit');
               GetKeys(Ch,Ch2);
               IF Ch = #27 THEN HaltProgram;
               ClearLine(23);
               ClearLine(24);
               ClearLine(25);
               SetCursorSize(Cursor);
END;
FUNCTION InputInteger(     X,Y,Field : Byte;
                           Low,High  : Integer;
                       VAR Value     : Integer) : Boolean;
         VAR
              St     : String[20];
              Ch,Ch2 : Char;
              Err    : Integer;
              Holder : Integer;
         LABEL
              LOOP;
         BEGIN
              Holder := Value;
             LOOP:
              St := '                    ';
              GoToXY(X,Y);
              St[0] := Char(Field);
              Write(St);
              GoToXY(X,Y);
              St[0] := #0;
              REPEAT
                    GetKeys(Ch,Ch2);
                    IF (Ch IN ['0'..'9','-']) AND
                       (St[0] < Char(Field)) THEN BEGIN
                       St := St + Ch;
                       Write(Ch);
                    END;
                    IF (Ch = #8) AND (St[0] <> #0) THEN BEGIN
                          Dec(St[0]);
                          Write(Ch);
                          Write(#32);
                          Write(Ch);
                    END;
                    IF Ch = #27 THEN BEGIN
                       InputInteger := TRUE;
                       Exit;
                    END;
              UNTIL Ch = #13;
              IF St[0] = #0 THEN BEGIN
                  GoToXY(X,Y);
                  Write(Value:Field);
                  InputInteger := FALSE;
              END
              ELSE BEGIN
                   Val(St,Holder,Err);
                   IF Err <> 0 THEN BEGIN
                      InputErrors(Low,High,1);
                      GOTO LOOP;
                   END;
                   IF (Holder < Low) OR (Holder > High) THEN BEGIN
                      InputErrors(Low,High,2);
                      GOTO LOOP;
                   END;
                   Value        := Holder;
                   InputInteger := FALSE;
             END;
END;
FUNCTION InputText(     X,Y       : Byte;
                    VAR St        : String) : Boolean;
         VAR
              Ch,Ch2 : Char;
         LABEL
              LOOP;
         BEGIN
             LOOP:
              GoToXY(X,Y);
              St[0] := #0;
              REPEAT
                    GetKeys(Ch,Ch2);
                    IF NOT (Ch IN [#8,#27,#13]) THEN BEGIN
                       St := St + Ch;
                       Write(Ch);
                    END;
                    IF (Ch = #8) AND (St[0] <> #0) THEN BEGIN
                          Dec(St[0]);
                          Write(Ch);
                          Write(#32);
                          Write(Ch);
                    END;
                    IF Ch = #27 THEN BEGIN
                       InputText := TRUE;
                       Exit;
                    END;
              UNTIL Ch = #13;
              InputText := (St[0] = #0);
END;
FUNCTION InputReal(        X,Y,Field,Decimals : Byte;
                           Low,High           : real;
                       VAR Value              : Single) : Boolean;
         VAR
              St     : String[20];
              Ch,Ch2 : Char;
              Err    : Integer;
              Holder : Single;
         LABEL
              LOOP;
         BEGIN
              Holder := Value;
             LOOP:
              St := '                    ';
              GoToXY(X,Y);
              St[0] := Char(Field);
              Write(St);
              GoToXY(X,Y);
              St[0] := #0;
              REPEAT
                    GetKeys(Ch,Ch2);
                    IF (Ch IN ['0'..'9','-','.']) AND
                       (St[0] < Char(Field)) THEN BEGIN
                       St := St + Ch;
                       Write(Ch);
                    END;
                    IF (Ch = #8) AND (St[0] <> #0) THEN BEGIN
                          Dec(St[0]);
                          Write(Ch);
                          Write(#32);
                          Write(Ch);
                    END;
                    IF Ch = #27 THEN BEGIN
                       InputReal := TRUE;
                       Exit;
                    END;
              UNTIL Ch = #13;
              IF St[0] = #0 THEN BEGIN
                  GoToXY(X,Y);
                  Write(Value:Field:Decimals);
                  InputReal := FALSE;
              END
              ELSE BEGIN
                   IF St[1] = '.' THEN
                      St := '0' + St;
                   Val(St,Holder,Err);
                   IF Err <> 0 THEN BEGIN
                      InputErrors(Low,High,1);
                      GOTO LOOP;
                   END;
                   IF (Holder < Low) OR (Holder > High) THEN BEGIN
                      InputErrors(Low,High,2);
                      GOTO LOOP;
                   END;
                   Value        := Holder;
                   InputReal := FALSE;
             END;
END;
FUNCTION InputExtended(        X,Y,Field,Decimals : Byte;
                               Low,High           : Single;
                           VAR Value              : Extended) : Boolean;
         VAR
              St     : String[20];
              Ch,Ch2 : Char;
              Err    : Integer;
              Holder : Extended;
         LABEL
              LOOP;
         BEGIN
              Holder := Value;
             LOOP:
              St := '                    ';
              GoToXY(X,Y);
              St[0] := Char(Field);
              Write(St);
              GoToXY(X,Y);
              St[0] := #0;
              REPEAT
                    GetKeys(Ch,Ch2);
                    IF (Ch IN ['0'..'9','-','.']) AND
                       (St[0] < Char(Field)) THEN BEGIN
                       St := St + Ch;
                       Write(Ch);
                    END;
                    IF (Ch = #8) AND (St[0] <> #0) THEN BEGIN
                          Dec(St[0]);
                          Write(Ch);
                          Write(#32);
                          Write(Ch);
                    END;
                    IF Ch = #27 THEN BEGIN
                       InputExtended := TRUE;
                       Exit;
                    END;
              UNTIL Ch = #13;
              IF St[0] = #0 THEN BEGIN
                  GoToXY(X,Y);
                  Write(Value:Field:Decimals);
                  InputExtended := FALSE;
              END
              ELSE BEGIN
                   IF St[1] = '.' THEN
                      St := '0' + St;
                   Val(St,Holder,Err);
                   IF Err <> 0 THEN BEGIN
                      InputExtendedErrors(Low,High,1);
                      GOTO LOOP;
                   END;
                   IF (Holder < Low) OR (Holder > High) THEN BEGIN
                      InputExtendedErrors(Low,High,2);
                      GOTO LOOP;
                   END;
                   Value        := Holder;
                   InputExtended := FALSE;
             END;
END;
PROCEDURE CreateHabitatArr(VAR Arr : HabitatArr);
          VAR
             Ct : Word;
          BEGIN
               IF MemAvail > LongInt(HabitatLength) * LongInt(HabitatWidth)
                  THEN BEGIN
                  FOR Ct := 1 TO HabitatLength DO BEGIN
                      GetMem(Arr[Ct],HabitatWidth);
                      ZeroFill(Arr[Ct]^,HabitatWidth);
                  END;
               END
               ELSE
                   FatalErrors(2);
END;

PROCEDURE DestroyHabitatArr(VAR Arr : HabitatArr);
          VAR
             Ct : Word;
          BEGIN
                  FOR Ct := 1 TO HabitatLength DO BEGIN
                      FreeMem(Arr[Ct],HabitatWidth);
                  END;
END;
(****SaveToFile is used for all file saves for all
 file input****)

PROCEDURE SaveToFile(Flag : Integer;OwlFile,Menu : Boolean);
          VAR
             OutF     : Text;
             Ch,Ch2   : Char;
             Ct1,Ct2  : Word;
             FileName : String;
          LABEL
               LOOP;
          BEGIN
               LOOP:
               ClrScr;
               IF Menu THEN BEGIN
                  SlowWrite(21,12,'Save map as a file? (Y/N) : ');
                  Ch := ReturnYesNo;
               END
               ELSE
                   Ch := 'Y';
               IF Ch = 'Y' THEN BEGIN
                  SlowWrite(21,14,'The file name : ');
                  ReadLn(FileName);
                  Assign(OutF,FileName);
                  ReSet(OutF);
                  IF IOResult = 0 THEN BEGIN
                     CenterText(23,ErrorVid,'The file already exists.');
                     CenterText(24,RevVid,
                                'Hit <ESC> to abort, any key to continue');
                     GetKeys(Ch,Ch2);
                     ClearLine(23);
                     ClearLine(24);
                     IF Ch = #27 THEN BEGIN
                        InputErrors(1,1,3);
                        GOTO LOOP;
                     END;
                  END;
                  ReWrite(OutF);
                  IF IOResult <> 0 THEN BEGIN
                     InputErrors(1,1,5);
                     GOTO LOOP;
                  END
                  ELSE BEGIN
                       WriteLn(OutF,Flag);
                       WriteLn(OutF,HabitatLength,' ',HabitatWidth);
                       FOR Ct1 := 1 TO HabitatLength DO
                           FOR Ct2 := 1 TO HabitatWidth DO BEGIN
                               IF OwlFile THEN
                                  Write(Outf,GetOwl(Habitat[Ct1]^[Ct2]),' ')
                               ELSE
                                  Write(Outf,Habitat[Ct1]^[Ct2],' ');
                               IF IOResult <> 0 THEN BEGIN
                                  Close(Outf);
                                  InputErrors(1,1,5);
                                  GOTO Loop;
                               END;
                           END;
                  END;
                  Close(Outf);
               END;
END;
PROCEDURE InputFileName(    StartX,StartY,BackColor,
                            HiColor                     : Byte;
                            St                          : String;
                        VAR Inf                         : Text;
                        VAR EscSw                       : Boolean);
          VAR
             FileName : String;
             S        : SearchRec;
             Posit,Ct : Word;
             AttHold  : Byte;
          LABEL
               Loop;
          BEGIN
               AttHold := TextAttr;
               TextAttr := BackColor;
               LOOP:
               SetCursorSize(NoCursor);
               ClrScr;
               Ct    := 0;
               Posit := 10;
               FindFirst('*.*',Archive,S);
               WHILE (DosError = 0) AND (Ct <= 60) DO BEGIN
                    VarFWrite(Posit,HiColor,S.Name);
                    FindNext(S);
                    Inc(Posit,40);
                    Inc(Ct);
                END;
                SlowWrite(StartX,StartY,St);
                SetCursorSize(Cursor);
                EscSw := InputText(StartX + Byte(St[0]),StartY,FileName);
                IF EscSw THEN
                   Exit;
                Assign(Inf,Filename);
                {$I-}
                Reset(Inf);
                {I+}
                IF IOResult <> 0 THEN BEGIN
                   InputErrors(1,1,5);
                   GOTO LOOP;
                END;
                TextAttr := AttHold;
                GlobInpFileName := FileName;
END;
PROCEDURE OutputFileName(    StartX,StartY,BackColor,
                             HiColor                     : Byte;
                             St                          : String;
                         VAR Inf                         : Text;
                         VAR EscSw                       : Boolean);
          VAR
             FileName : String;
             S        : SearchRec;
             Posit,Ct : Word;
             AttHold  : Byte;
          LABEL
               Loop;
          BEGIN
               AttHold := TextAttr;
               TextAttr := BackColor;
               LOOP:
               SetCursorSize(NoCursor);
               ClrScr;
               Ct    := 0;
               Posit := 10;
               FindFirst('*.*',Archive,S);
               WHILE (DosError = 0) AND (Ct <= 60) DO BEGIN
                    VarFWrite(Posit,HiColor,S.Name);
                    FindNext(S);
                    Inc(Posit,40);
                    Inc(Ct);
                END;
                SlowWrite(StartX,StartY,St);
                SetCursorSize(Cursor);
                EscSw := InputText(StartX + Byte(St[0]),StartY,FileName);
                IF EscSw THEN
                   Exit;
                Assign(Inf,Filename);
                Reset(Inf);
                IF IOResult = 0 THEN BEGIN
                   InputErrors(1,1,8);
                   Close(Inf);
                END;
                ReWrite(Inf);
                IF IOResult <> 0 THEN BEGIN
                   InputErrors(1,1,5);
                   GOTO LOOP;
                END;
                TextAttr := AttHold;
                GlobOutFileName := FileName;
END;

PROCEDURE SetColors;
          BEGIN
               IF Color THEN BEGIN
                  Video1     := 30;
                  Video2     := 31;
                  HiVid      := 28;
                  RevVid     := 112;
                  RevVid2    := 63;
                  ErrorVid   := 79;
                  UnderVid   := 28;
                  TextAttr   := Video2;
               END;
END;
BEGIN
END.