{MapBind contains the procedures necessary to create a 'bound' file
 for dynamic map creation and allows that file to be read by sim}

Unit MapBind;

Interface

uses owlasm,BindGlob,Global;

CONST
        BoundFileFirstTime : Boolean = TRUE;
        YearCtr            : Word    = 0;
VAR
   Inp      : Text;
   OutP     : File;
   boundmap : BindRecord;
Procedure BindMaps(VAR BindRules   : BindRecord;
                   VAR FileNames   : FileNameArr;
                       OutFileName : String);
Function ReadBoundStack(    FileName : String;
                             X,Y,Year : Word;
                         VAR Map      : HabitatArr): Boolean;

implementation

{this procedure will take a series of map files and bind them into
 a single binary file}
 


Procedure HaltProgram;
          VAR
             x : Integer;
          begin
               Close(Inp);
               x := IOResult;
               Close(OutP);
               x := IOResult;
               Halt;
end;
Procedure FileErrors(N : Byte);
          VAR
             st : String;
          begin
               if IOResult <> 0 then begin
                  Case N of
                       1 : St := 'File not found';
                       2 : St := 'Error in file write';
                       3 : St := 'Error in file read';
                  end;
                  WriteLn(St);
                  HaltProgram;
               end;
end;
Procedure FatalErrors(N : Byte);
          VAR
             st : String;
          begin
               Case N of
                    1 : St := 'Flag value indicates improper file type';
                    2 : St := 'Map Dimensions Wrong';
               end;
               WriteLn(St);
               HaltProgram;
end;
Procedure DumpBuffer(VAR Ct     : Word;
                     VAR OutBuff;
                     VAR F      : File);
          begin
               BlockWrite(F,OutBuff,Ct);
               FileErrors(2);
               Ct := 0;
end;
Procedure BindMaps(VAR BindRules   : BindRecord;
                   VAR FileNames   : FileNameArr;
                       OutFileName : String);
          Type
              Buffer     = Array[1..30000] of Byte;
              BuffPtr    = ^Buffer;
          VAR
             InpBuff,OutPBuff : BuffPtr;
             Ct,l,w,BuffCtr   : Word;
             TotalN,Ct2       : LongInt;
             F                : Integer;
          begin
               New(InpBuff);
               New(OutpBuff);
               Assign(OutP,OutFileName);
               Rewrite(OutP,1);
               FileErrors(2);
               BlockWrite(OutP,BindRules,SizeOf(BindRecord));
               With BindRules do begin
                    For Ct := 1 to MapNumber do begin
                        Assign(Inp,FileNames[Ct]);
                        Reset(Inp);
                        SetTextBuf(Inp,InpBuff^);
                        FileErrors(1);
                        ReadLn(Inp,F);
                        if F <> Flag then
                           FatalErrors(1);
                        ReadLn(Inp,w,l);
                        if (w <> EWSize) or (l <> NSSize) then
                           FatalErrors(2);
                        totalN := LongInt(w) * l;
                        BuffCtr := 0;
                        for Ct2 := 1 to TotalN do begin
                            Inc(BuffCtr);
                            if BuffCtr > SizeOf(Buffer) then
                               DumpBuffer(BuffCtr,OutPBuff^,Outp);
                            Read(Inp,OutPBuff^[BuffCtr]);
                            FileErrors(3);
                        end;
                        Close(Inp);
                        DumpBuffer(BuffCtr,OutPBuff^,Outp);
                    end;
                    Close(Outp);
               end;
end;

{This procedure reads through a bound stack of maps and places the new maps
into a map array}

Function  ReadBoundStack(    FileName : String;
                             X,Y,Year : Word;
                         VAR Map      : HabitatArr):Boolean;
          Const
               FirstTime : Boolean = True;
               YearCtr   : Word    = 0;
          Type
              Buffer     = Array[1..10] of Byte;
              BuffPtr    = ^Buffer;
          VAR
             OutPBuff     : BuffPtr;
             Ct,Ct2       : Word;
             Res          : Boolean;
          Label
               Finis;
          begin
               Res := False;
               if Year = 1 then begin         {a new run}
                  FirstTime := True;
                  Close(OutP);
                  Ct := IOResult;
                  YearCtr := 0;
               end;
               if YearCtr > BoundMap.MapNumber then Goto FINIS;
               With BoundMap do begin
                    if FirstTime then begin
                       Assign(OutP,FileName);
                       Reset(OutP,1);
                       FileErrors(1);
                       BlockRead(OutP,BoundMap,SizeOf(BoundMap));
                            if Flag <> BoundFlag then
                               FatalErrors(1);
                            if (EWSize <> X) or (NSSize <> y) then
                               FatalErrors(2);
                            YearCtr := 1;
                            FirstTime := False;
                    end;
                    if (YearCtr <= MapNumber) and
                       (Year = EntryLog[YearCtr]) then begin
                       Res := True;
                       GetMem(OutPBuff,X);
                       for Ct := 1 to y do begin
                           BlockRead(OutP,OutPBuff^,X);
                           FileErrors(3);
                           For Ct2 := 1 to x do
                               ChangeClass(GetClass(OutPBuff^[Ct2]),
                                           Map[Ct]^[Ct2]);
                       end;
                       Inc(YearCtr);
                       FreeMem(OutPBuff,X);
                    end;
                    if YearCtr > MapNumber then
                       Close(OutP);
               end;
           FINIS:
               ReadBoundStack := Res;
end;
begin
end.





