
{all of the procedures necessary to get the right data to the right places
 if multiple runs are taking place}

UNIT MultRun;
INTERFACE

USES Global,RuleSet,Output,Utility;

PROCEDURE PlaceTempFile;
PROCEDURE RetrieveTempFile;
PROCEDURE KillTempFile;
PROCEDURE OutputRules(FileName : String);
PROCEDURE MultipleOutput(RunNo : Word;VAR Outf : Text);
PROCEDURE MultipleOutput2(RunNo : Word; VAR Outf : Text; Extinct: Boolean);
PROCEDURE ZeroEverything;

IMPLEMENTATION

{PlaceTempFile and RetrieveTempFile place and retrieve a binary copy of the
 map to and from disk}

PROCEDURE PlaceTempFile;
          VAR
             Ct      : Word;
             OutF    : File;
          BEGIN
               Assign(Outf,'HABITAT.QZX');
               ReWrite(OutF,1);
               IF IOResult <> 0 THEN
                  FatalErrors(4);
               FOR Ct := 1 TO HabitatLength DO BEGIN
                   BlockWrite(OutF,Habitat[Ct]^,HabitatWidth);
                   IF IOResult <> 0 THEN
                      FatalErrors(4);
               END;
               Close(Outf);
END;
PROCEDURE RetrieveTempFile;
          VAR
             Ct      : Word;
             OutF    : File;
          BEGIN
               Assign(Outf,'HABITAT.QZX');
               ReSet(OutF,1);
               IF IOResult <> 0 THEN
                  FatalErrors(4);
               FOR Ct := 1 TO HabitatLength DO BEGIN
                   BlockRead(OutF,Habitat[Ct]^,HabitatWidth);
                   IF IOResult <> 0 THEN
                      FatalErrors(4);
               END;
               Close(Outf);
END;
PROCEDURE KillTempFile;
          VAR
             Ct      : Word;
             OutF    : File;
          BEGIN
               Assign(Outf,'HABITAT.QZX');
               Erase(OutF);
END;

PROCEDURE OutputRules(FileName : String);
          VAR
             OutF : Text;
             LastCh : Byte;
          BEGIN
               LastCh := LastCharPos('.',FileName);
               IF LastCh <> 0 THEN
                  FileName[0] := Char(Pred(LastCh));
               FileName := FileName + '.QZX';
               Assign(OutF,FileName);
               ReWrite(OutF);
               IF IOResult <> 0 THEN
                  FatalErrors(6);
               WriteInitData(Outf);
               Close(OutF);
END;
PROCEDURE MultipleOutput(RunNo : Word;VAR Outf : Text);
          VAR
             Ct, PopTotal,i : Word;
          BEGIN

               IF RunNo = 1 THEN BEGIN
                  WriteLn(OutF,-7777);
                  WriteLn(OutF,Runs,' ',Years, ' ',MaxStage);
               END;
               FOR Ct := 1 TO Years DO BEGIN
                   PopTotal := 0;
                   Write(Outf, Ct, ' ');
                   FOR i := 0 TO maxstage DO BEGIN
                      Write(Outf,  Totals[Ct]^[i], ' ');
                      Inc(PopTotal, Totals[Ct]^[i]);
                   END;
                   WriteLn(outf, PairStartCtr[Ct], ' ',PopTotal,' ',GenesLost[Ct]:5:3);
                   IF IOResult <> 0 THEN
                      FatalErrors(5);
               END;
END;
PROCEDURE MultipleOutput2(RunNo : Word; VAR Outf : Text; Extinct: Boolean);
VAR
    Ct, Ct2 : Word;
    PairTotal : Word;
    PairMean  : Single;
BEGIN
   IF RunNo = 1 THEN BEGIN
      WriteLn(OutF,-7777);
      WriteLn(OutF,Runs,' ',Years, ' ');
   END;
   PairTotal := 0;
   FOR Ct := (Years - 9) TO Years DO 
      Inc(PairTotal, PairStartCtr[Ct]);
   PairMean := Pairtotal/10;
   For Ct2 := 1 TO Pred(NumRules) DO
   Write(Outf, Rule[Ct2]:8:4);
   Write(Outf, Trunc(Rule[NumRules]):4);
   FOR Ct2 := 1 TO 8 DO
   Write(Outf, SigmaArray[Ct2]:8:4);
   Write(outf, PairMean :8:1);
   IF Extinct THEN WriteLn(outf, '  0')
   Else WriteLn(Outf,'  1');
   IF IOResult <> 0 THEN
      FatalErrors(5);
END;

PROCEDURE ZeroEverything;
          VAR
             Ct : Word;
          BEGIN
               YrCtr := 0;
               FledgeTotal := 0;
               YrCtr := 0;
               GraphOn := FALSE;
               ZoomXStart := 1;
               ZoomYStart := 1;          
               ZeroFill(PairStartCtr,SizeOf(DataArray));
               ZeroFill(GenesLost,SizeOf(RealDataArray));
               FOR Ct := 1 TO Years DO
                  ZeroFill(Totals[Ct]^,SizeOf(Totals[Ct]^));
               WITH Owls DO BEGIN
                    ZeroFill(MalePop^,SizeOf(MaleArr));
                    ZeroFill(FemalePop^,SizeOf(FemaleArr));                   
                    ZeroFill(PairPop^,SizeOf(PairArr));
                    MaleCtr := 0;
                    FemaleCtr := 0;
                    PairCtr := 0;
               END;

END;
BEGIN
END.







