UNIT Output;

INTERFACE

USES Crt,RuleSet,Global,Menus,ScrLib,LineGra,ClassDef, Beta;

PROCEDURE OutputMenu(VAR SimAgain : Boolean);
PROCEDURE WriteInitData(VAR OutF : Text);

IMPLEMENTATION

TYPE
    StringArr = Array[1..12] OF String[10];
CONST
     OwlDataArray   : StringArr =
     ( 'Pairs','Total', 'Age 0',  'Age 1',  'Age 2',  'Age 3',  'Age 4',  'Age 5',  'Age 6',  'Age 7',
       'Age 8',  'Age 9');
FUNCTION MakeDashedLine : String;
         VAR
            TempSt : String;
        BEGIN
             FillChar(TempSt[1],79,'-');
             TempSt[0] := #79;
             MakeDashedLine := Tempst;
END;
FUNCTION MakeStringfield(St : String;FieldWidth : Byte):String;
         VAR
            TempSt : String;
            Ct,Ctr : Byte;
         BEGIN
              FillChar(TempSt[1],FieldWidth,#32);
              TempSt[0] := Char(FieldWidth);
              IF St[0] = #0 THEN
                 MakeStringField := TempSt
              ELSE BEGIN
                  IF Byte(St[0]) > FieldWidth THEN
                     St[0] := Char(FieldWidth);
                  Ctr := Succ(Byte(St[0]));
                  FOR Ct := FieldWidth DOWNTO (FieldWidth - Pred(Byte(St[0]))) DO
                      BEGIN
                      Dec(Ctr);
                      TempSt[Ct] := St[Ctr];
                  END;
                  MakeStringField := TempSt;
             END;

END;
FUNCTION MakeIntegerField(X : Integer;FieldWidth : Byte):String;
         VAR
            TempSt : String;
         BEGIN
              IF X = 0 THEN BEGIN
                 FillChar(TempSt[1],FieldWidth,#32);
                 TempSt[0] := Char(FieldWidth);
                 TempSt[Length(TempSt)] := '-';
              END
              ELSE
                   Str(X:FieldWidth,TempSt);
              MakeIntegerField := TempSt;
END;
FUNCTION MakeIntegerField2(X : Integer;FieldWidth : Byte):String;
         VAR
            TempSt : String;
         BEGIN
              IF X = 0 THEN BEGIN
                 FillChar(TempSt[1],FieldWidth,#32);
                 TempSt[0] := Char(FieldWidth);
                 TempSt[Length(TempSt)] := '0';
              END
              ELSE
                   Str(X:FieldWidth,TempSt);
              MakeIntegerField2 := TempSt;
END;
FUNCTION MakeRealField(X : Single;FieldWidth,Decimals : Byte):String;
         VAR
            TempSt : String;
         BEGIN
              IF X = 0 THEN BEGIN
                 FillChar(TempSt[1],FieldWidth,#32);
                 TempSt[0] := Char(FieldWidth);
                 TempSt[Length(TempSt)] := '-';
              END
              ELSE
                   Str(X:FieldWidth:Decimals,TempSt);
              MakeRealField := TempSt;
END;
FUNCTION MakeRealField2(X : Single;FieldWidth,Decimals : Byte):String;
         VAR
            TempSt : String;
         BEGIN
              Str(X:FieldWidth:Decimals,TempSt);
              MakeRealField2 := TempSt;
END;
FUNCTION MakeCenteredString(St : String):String;
         VAR
            TempSt : String;
            Start  : Byte;
            Ct,Ctr : Byte;
         BEGIN
              IF St[0] > #78 THEN
                 St[0] := #78;
              Start := (80 - Byte(St[0])) SHR 1;
              FillChar(TempSt[1],80,#32);
              TempSt[0] := Char(Start + Pred(Byte(St[0])));
              Ctr := 0;
              FOR Ct := Start TO (Pred(Start) + Byte(St[0])) DO BEGIN
                  Inc(Ctr);
                  TempSt[Ct] := St[Ctr];
              END;
              MakeCenteredString := TempSt;
END;
PROCEDURE WriteRealClassData(VAR Outf  : Text;
                                 St    : String;
                             VAR Arr   : RealCriteria;
                                 Field : Byte);
          VAR
             Ct : Byte;
          BEGIN
               Write(OutF,MakeStringField(St,Field));
               FOR Ct := 1 TO LandScapeClasses DO
                   Write(OutF,MakeRealField(Arr[Ct],Field,2));
               WriteLn(OutF,'');
END;
PROCEDURE WriteIntClassData(VAR Outf  : Text;
                                 St    : String;
                             VAR Arr   : AcceptCriteria;
                                 Field : Byte);
          VAR
             Ct : Byte;
          BEGIN
               Write(OutF,MakeStringField(St,Field));
               FOR Ct := 1 TO LandScapeClasses DO
                   Write(OutF,MakeRealField(Arr[Ct],Field,2));
               WriteLn(OutF,'');
END;
PROCEDURE StartDataType(VAR Outf  : Text;
                            St    : String;
                            Arr   : ClassNameArr;
                            N     : Byte;
                            Field : Byte);
          VAR
             Ct : Byte;
          BEGIN
          WriteLn(OutF,MakeDashedLine);
          Write(OutF,MakeStringField(St,Field));
          FOR Ct := 1 TO N DO
              Write(OutF,MakeStringField(Arr[Ct],Field));
          WriteLn(OutF,'');
          WriteLn(OutF,MakeDashedLine);
END;
PROCEDURE StartDataType2(VAR Outf  : Text;
                             St    : String;
                             Arr   : StringArr;
                             N     : Byte;
                             Field : Byte);
          VAR
             Ct : Byte;
          BEGIN
          WriteLn(OutF,MakeDashedLine);
          Write(OutF,MakeStringField(St,Field));
          FOR Ct := 1 TO N DO
              Write(OutF,MakeStringField(Arr[Ct],Field));
          WriteLn(OutF,'');
          WriteLn(OutF,MakeDashedLine);
END;
FUNCTION DispBoundary : String;
         BEGIN
              CASE BoundaryCondition OF
                   1 : DispBoundary := 'Reflecting';
                   2 : DispBoundary := 'Absorbing';
                   3 : DispBoundary := 'Wrap-Around';
              END;
END;
PROCEDURE WriteNameAndComment(Name,Comment : String;VAR OutF : Text);
          VAR
             Ct : Word;
          BEGIN
               FOR Ct := 1 TO 20 DO
                   WriteLn(OutF);
               WriteLn(OutF,MakeCenteredString(Name));
               WriteLn(OutF);
               WriteLn(OutF,Comment);
               WriteLn(OutF,#12);
END;
PROCEDURE WriteInitData(VAR OutF : Text);
          VAR
             Ct,Field : Byte;
             StageNo  : String[2];
             Title    : String[10];
          BEGIN
               Field := 80 DIV Succ(LandscapeClasses);
               WriteLn(OutF,MakeCenteredString('START UP PARAMETERS'));
               WriteLn(OutF,'');
               StartDataType(Outf,'',ClassNameArray,LandscapeClasses,Field);
               Writeln(OutF, 'NUMBER OF AGE CLASSES = ', Stages);
               WriteLn(Outf, 'MEAN SURVIVAL PROBABILITIES');
               FOR ct := 0 To (Stages-1) DO BEGIN
                 Str(ct, StageNo);
                 Title   := Concat('Stage ', StageNo);
                 WriteRealClassData(Outf, Title, SurvivalMean[ct],Field);
               END;
               Writeln(outf, 'VARIANCE OF SURVIVAL PROBABILITIES');
               FOR ct := 0 To (Stages-1) DO BEGIN
                 Str(ct, StageNo);
                 Title   := Concat('Stage ', StageNo);
                 WriteRealClassData(Outf, Title, SurvivalVar[ct],Field);
               END;
               StartDataType(Outf,'',ClassNameArray,LandscapeClasses,Field);
               WriteLn(outf, 'MEAN FLEDGE PROBABILITIES');
               FOR ct := 0 To (Stages-1) DO BEGIN
                 Str(ct, StageNo);
                 Title   := Concat('Stage ', StageNo);
                 WriteRealClassData(Outf,Title, FledgeMean[ct],Field);
               END;
               writeln(outf, 'VARIANCE IN FLEDGE PROBABILITY');
               FOR ct := 0 To (Stages-1) DO BEGIN
                  Str(ct, StageNo);
                  Title   := Concat('Stage ', StageNo);
                  WriteRealClassData(Outf, Title, FledgeVar[ct],Field);
               END;
               WriteLn(outf, 'Fledge Number  = ',FledgeNo);
               WriteLn(Outf, 'Male Prob. of Fledging = ',MaleFledgeProb:4:2);
               StartDataType(Outf,'',ClassNameArray,LandscapeClasses,Field);
               WriteLn(OutF,'MOVEMENT');
               WriteIntClassData(Outf,'Nesting OK',LandClassOK,Field);
               WriteRealClassData(Outf,'Aversion',Aversion,Field);
               WriteLn(OutF,'Prob. Female Finds Male   = ',FemSearchProb:4:2);
               WriteLn(OutF,'Male Territorial Aversion = ',PairAversion:4:2);
               WriteLn(OutF,'Directionial Weighting    = ',DirectionalWeight:4:2);
               WriteRealClassData(OutF,'WanderL',WanderLust,Field);
               WriteLn(OutF,'Boundary Condition        = ',DispBoundary);
               WriteLn(OutF,MakeDashedLine);
               WriteLn(OutF,'TIME SERIES');
               WriteLn(OutF,'Total number of runs = ',Runs,' Total run length = ',Years,' Years');
               WriteLn(OutF,'Delta-t          = ',DeltaT);
               WriteLn(OutF,#12);
END;
PROCEDURE FullData(VAR OutF : Text);
          VAR
             Ct,i  : Word;
             Field : Word;
             TotalPop : Word;
          BEGIN
               Field := 80 DIV 11;
               WriteLn(OutF,MakeCenteredString('YEARLY DATA'));
               WriteLn(OutF);
               StartDataType2(Outf,'Year',OwlDataArray,9,Field);
               FOR Ct := 1 TO YrCtr DO BEGIN
                  Write(Outf,MakeIntegerField(Ct,Field));
                  TotalPop := 0;
                  FOR i := 0 TO (Stages - 1) DO BEGIN
                     Write(OutF,MakeIntegerField2(Totals[Ct]^[i],Field));
                     Inc(TotalPop, Totals[Ct]^[i]);
                  END;
                  Write(OutF,MakeIntegerField2(PairStartCtr[Ct],Field));
                  Write(OutF,MakeIntegerField2(TotalPop,Field));
                  Write(OutF,MakeRealField2(GenesLost[Ct],Field,2));
                  WriteLn(OutF);
               END;
END;

FUNCTION Avg(VAR Arr : DataArray):Single;
         VAR
            Ct  : Word;
            Sum : LongInt;
         BEGIN
              Sum := 0;
              FOR Ct := 1 TO YrCtr DO
                  Sum := Sum + Arr[Ct];
              Avg := Sum/YrCtr;
END;
PROCEDURE SummaryStats(VAR OutF : Text);
          VAR
             i, Ct : Word;
             Field : Byte;
             TotalPop : Word;
          BEGIN
               Field := 80 DIV 8;
               StartDataType2(Outf,' ',OwlDataArray,MaxStage +3,Field);
               Write(OutF,MakeStringField('Init. Pop.',Field));
               TotalPop := 0;
               FOR i := 0 TO MaxStage DO
                  Inc(TotalPop, Totals[0]^[i]);
               Write(Outf, MakeIntegerField(PairStartCtr[1],FIeld),
                           MakeIntegerField(TotalPop,Field));
               FOR i := 0 TO MaxStage DO  
                   Write(Outf,MakeIntegerField(Totals[0]^[i],   Field));
               Writeln(Outf);               
               TotalPop := 0;
                 FOR i := 0 TO MaxStage DO
                  Inc(TotalPop, Totals[YrCtr]^[i]);
               Write(OutF,MakeStringField('Final Pop.',Field));
               Write(Outf, MakeIntegerField(PairStartCtr[YrCtr],Field),
                            MakeIntegerField(TotalPop,Field));
               FOR i := 0 TO MaxStage DO 
                  Write(Outf, MakeIntegerField(Totals[YrCtr]^[i],Field));
               writeln(outf);
              WriteLn(OutF,MakeDashedLine);
              WriteLn(OutF,'Total run length = ',YrCtr);
              IF PairDistance.N <> 0 THEN
                 WriteLn(OutF,'Average Distance before pairing = ',
                          PairDistance.Sumdist/PairDistance.N:10:3);
              IF DeathDistance.N <> 0 THEN
                 WriteLn(OutF,'Average Distance before death   = ',
                          DeathDistance.Sumdist/DeathDistance.N:10:3);
END;
PROCEDURE OutputToFile(VAR OutF : Text);
          VAR
             RunName,Comment : String;
          BEGIN
               ClrScr;
               RunName := '';
               SlowWrite(1,11,'The title : ');
               ReadLn(RunName);
               Comment := '';
               WriteLn;
               WriteLn('Any comments : ');
               ReadLn(Comment);
               ClrScr;
               WriteNameAndComment(RunName,Comment,OutF);
               WriteInitData(OutF);
               FullData(OutF);
               Write(OutF,#12);
               Close(OutF);
END;
PROCEDURE OutputToScreen(VAR OutF : Text);
          VAR
             Ch,Ch2 : Char;
          BEGIN
               Ch := InputMenu(ScreenCh);
               IF Ch = 'G' THEN
                  CallGraph
               ELSE BEGIN
                    SetCursorSize(NoCursor);
                    ClrScr;
                    SummaryStats(OutF);
                    CenterText(25,63,'Any Key to Continue');
                    GetKeys(Ch,Ch2);
                    SetCursorSize(Cursor);
               END;
END;
PROCEDURE ChooseOutputForm(VAR EscSw : Boolean);
          VAR
             Ch   : Char;
             Outf : Text;
          LABEL
              Loop;
          BEGIN
               EscSw := FALSE;
               Ch := InputMenu(OutRed);
               CASE Ch OF
                    'F' : BEGIN
                               ClrScr;
                               OutputFileName(10,22,30,31,'The output file : ',OutF,EscSw);
                          END;
                    'P' : BEGIN
                               Loop:
                               Assign(OutF,'LPT1');
                               ReWrite(OutF);
                               WriteLn(Outf);
                               IF IOResult <> 0 THEN BEGIN
                                  InputErrors(1,1,7);
                                  ClearLine(22);
                                  ClearLine(23);
                                  ClearLine(24);
                                  GOTO Loop;
                               END;

                          END;
                    'S' : BEGIN
                               AssignCrt(OutF);
                               ReWrite(OutF);
                          END;
                    #27 : EscSw := TRUE;
               END;
               IF EscSw THEN
                  Exit
               ELSE BEGIN
                    IF Ch IN ['F','P'] THEN
                       OutputToFile(OutF)
                    ELSE
                        OutputToScreen(OutF);
               END;
END;
PROCEDURE OutputMenu(VAR SimAgain : Boolean);
          VAR
             Ch,Ch2                   : Char;
             FileName,Comment,RunName : String;
             OutF                     : Text;
             Err                      : Byte;
             EscSw                    : Boolean;
          LABEL
               LOOP;
          BEGIN
               SimAgain := FALSE;
               REPEAT
                  Ch := InputMenu(DispOut);
                  CASE Ch OF
                       'S' : BEGIN
                                  SimAgain := TRUE;
                                  Exit;
                             END;
                   #27,'Q' : Exit;
                       'D' : ChooseOutputForm(EscSw);
                  END;
               UNTIL FALSE;
END;

BEGIN
END.
