UNIT OwlAsm;

INTERFACE

{Procedures GetOwl, GetClass, KillOwl, IsOwl, MakeMultiple, NoMultiple and
IsMultiple are assembly procedures designed to speed up interface
with the map.  They are coded here as inline directives (inline code)}

FUNCTION GetOwl(ArrEntry: Byte):Byte;
INLINE(
 $58                     {POP     AX}
/$24/$0F                 {AND     AL,0F}
);

PROCEDURE AddOwl(Owl : Byte;VAR ArrayClass : Byte);

INLINE(
 $8C/$DA                 {MOV     DX,DS}
/$5E                     {POP     SI}
/$1F                     {POP     DS}
/$58                     {POP     AX}
/$8A/$0C                 {MOV     CL,[SI]}
/$80/$E1/$F0             {AND     CL,F0}
/$02/$C1                 {ADD     AL,CL}
/$88/$04                 {MOV     [SI],AL}
/$8E/$DA                 {MOV     DS,DX}
);

PROCEDURE KillOwl(VAR ArrayClass : Byte);
INLINE(
 $8C/$DA                 {MOV     DX,DS}
/$5E                     {POP     SI}
/$1F                     {POP     DS}
/$80/$24/$F0             {AND     BYTE PTR [SI],F0}
/$8E/$DA                 {MOV     DS,DX}
);

FUNCTION IsOwl(ArrayClass : Byte) : Boolean;

INLINE(
 $58                     {POP     AX}
/$24/$0F                 {AND     AL,0F}
/$0A/$C0                 {OR      AL,AL}
/$74/$02                 {JZ      01AD}
/$B0/$01                 {MOV     AL,01}
);

FUNCTION GetClass(ArrayClass : Byte):Byte;

INLINE(
 $58                     {POP     AX}
/$32/$E4                 {XOR     AH,AH}
/$24/$7F                 {AND     AL,7F}
/$C1/$E8/$04             {SHR     AX,4}
);

PROCEDURE ChangeClass(Class : Byte;VAR ArrayEntry : Byte);

INLINE(
 $8C/$DA                 {MOV     DX,DS}
/$5E                     {POP     SI}
/$1F                     {POP     DS}
/$58                     {POP     AX}
/$8A/$0C                 {MOV     CL,[SI]}
/$80/$E1/$8F             {AND     CL,8F}
/$32/$E4                 {XOR     AH,AH}
/$C1/$E0/$04             {SHL     AX,4}
/$0A/$C1                 {OR      AL,CL}
/$88/$04                 {MOV     [SI],AL}
/$8E/$DA                 {MOV     DS,DX}
);

PROCEDURE MakeMultiple(VAR Class : Byte);

INLINE(
 $8C/$DA                 {MOV     DX,DS}
/$5E                     {POP     SI}
/$1F                     {POP     DS}
/$80/$0C/$80             {OR      BYTE PTR [SI],80}
/$8E/$DA                 {MOV     DS,DX}
);

PROCEDURE NoMultiple(VAR Class : Byte);

INLINE(
 $8C/$DA                 {MOV     DX,DS}
/$5E                     {POP     SI}
/$1F                     {POP     DS}
/$80/$24/$7F             {AND     BYTE PTR [SI],7F}
/$8E/$DA                 {MOV     DS,DX}
);

FUNCTION IsMultiple(Class : Byte) : Boolean;

INLINE(
 $58                     {POP     AX}
/$24/$80                 {AND     AL,80}
/$0A/$C0                 {OR      AL,AL}
/$74/$02                 {JZ      01F4}
/$B0/$01                 {MOV     AL,01}
);


{Sequence and SwapWord are used during simulation}

PROCEDURE Sequence(N,Start,Jump : Word;VAR Arr);
INLINE
($5F                     {POP     DI}
/$07                     {POP     ES}
/$5B                     {POP     BX}
/$58                     {POP     AX}
/$59                     {POP     CX}
/$E3/$06                 {JCXZ    018B}
/$FC                     {CLD}
/$AB                     {STOSW}
/$03/$C3                 {ADD     AX,BX}
/$E2/$FB                 {LOOP    0186}
);

PROCEDURE SwapWord(Pos1,Pos2 : Word; VAR Arr);
INLINE
($8C/$DA                 {MOV     DX,DS}
/$5E                     {POP     SI}
/$1F                     {POP     DS}
/$8C/$D8                 {MOV     AX,DS}
/$8E/$C0                 {MOV     ES,AX}
/$8B/$FE                 {MOV     DI,SI}
/$58                     {POP     AX}
/$48                     {DEC     AX}
/$D1/$E0                 {SHL     AX,1}
/$03/$F0                 {ADD     SI,AX}
/$58                     {POP     AX}
/$48                     {DEC     AX}
/$D1/$E0                 {SHL     AX,1}
/$03/$F8                 {ADD     DI,AX}
/$8B/$05                 {MOV     AX,[DI]}
/$A5                     {MOVSW}
/$89/$44/$FE             {MOV     [SI-02],AX}
/$8E/$DA                 {MOV     DS,DX}
);

{Note Rand and RandWord can only be used on 287-387 equiped machines.
 Rand is always 1 random number behind (it outputs random number i and
 generates random number i+1).  This is done so that the co-processor
 commands can be more liberally sprinkled throughout the code. To ensure
 that the first number output = i rather than the starting seed, Rand is
 called once in the implementation}

{$IFDEF COPROC387}

CONST
     RandomHolder : Single = 4.656612873E-10; {required}
FUNCTION RAND : Single;
INLINE
(
 $DB/$06/RandSeed        {FILD    DWORD PTR [RandSeed]}
/$A1/RandSeed            {MOV     AX,[RandSeed]}
/$8B/$1E/RandSeed+2      {MOV     BX,[RandSeed+2]}
/$8B/$C8                 {MOV     CX,AX}
/$BF/$05/$84             {MOV     DI,8405}
/$F7/$E7                 {MUL     DI}
/$C1/$E1/$03             {SHL     CX,3}
/$02/$E9                 {ADD     CH,CL}
/$03/$D1                 {ADD     DX,CX}
/$D9/$E1                 {FABS}
/$03/$D3                 {ADD     DX,BX}
/$C1/$E3/$02             {SHL     BX,2}
/$03/$D3                 {ADD     DX,BX}
/$02/$F3                 {ADD     DH,BL}
/$D8/$0E/RandomHolder    {FMUL    DWORD PTR [RandomHolder]}
/$C1/$E3/$05             {SHL     BX,5}
/$02/$F3                 {ADD     DH,BL}
/$05/$01/$00             {ADD     AX,0001}
/$83/$D2/$00             {ADC     DX,+00}
/$A3/RandSeed            {MOV     [RandSeed],AX}
/$89/$16/RandSeed+2      {MOV     [RandSeed+2],DX}
);

{$ELSE}


CONST
     RandomHolder : Integer = -31; {required}
FUNCTION RAND : Single;
INLINE
(
 $DF/$06/RandomHolder    {FILD    WORD PTR [RandomHolder]}
/$A1/RandSeed            {MOV     AX,[RandSeed]}
/$8B/$1E/RandSeed+2      {MOV     BX,[RandSeed+2]}
/$8B/$C8                 {MOV     CX,AX}
/$BF/$05/$84             {MOV     DI,8405}
/$F7/$E7                 {MUL     DI}
/$DB/$06/RandSeed        {FILD    DWORD PTR [RandSeed]}
/$C1/$E1/$03             {SHL     CX,3}
/$02/$E9                 {ADD     CH,CL}
/$03/$D1                 {ADD     DX,CX}
/$03/$D3                 {ADD     DX,BX}
/$C1/$E3/$02             {SHL     BX,2}
/$03/$D3                 {ADD     DX,BX}
/$02/$F3                 {ADD     DH,BL}
/$D9/$E1                 {FABS}
/$C1/$E3/$05             {SHL     BX,5}
/$02/$F3                 {ADD     DH,BL}
/$D9/$FD                 {FSCALE}
/$05/$01/$00             {ADD     AX,0001}
/$83/$D2/$00             {ADC     DX,+00}
/$A3/RandSeed            {MOV     [RandSeed],AX}
/$DD/$D9                 {FSTP    ST(1)}
/$89/$16/RandSeed+2      {MOV     [RandSeed+2],DX}
);

{$ENDIF}

FUNCTION RandWord(X : Word) : Word;
INLINE
($A1/RandSeed            {MOV     AX,[RandSeed]}
/$8B/$1E/RandSeed+2      {MOV     BX,[RandSeed+2]}
/$8B/$C8                 {MOV     CX,AX}
/$BF/$05/$84             {MOV     DI,8405}
/$F7/$E7                 {MUL     DI}
/$C1/$E1/$03             {SHL     CX,3}
/$02/$E9                 {ADD     CH,CL}
/$03/$D1                 {ADD     DX,CX}
/$03/$D3                 {ADD     DX,BX}
/$C1/$E3/$02             {SHL     BX,2}
/$03/$D3                 {ADD     DX,BX}
/$02/$F3                 {ADD     DH,BL}
/$C1/$E3/$05             {SHL     BX,5}
/$02/$F3                 {ADD     DH,BL}
/$05/$01/$00             {ADD     AX,0001}
/$83/$D2/$00             {ADC     DX,+00}
/$A3/RandSeed            {MOV     [RandSeed],AX}
/$89/$16/RandSeed+2      {MOV     [RandSeed+2],DX}
/$33/$C0                 {XOR     AX,AX}
/$5B                     {POP     BX}
/$0B/$DB                 {OR      BX,BX}
/$74/$05                 {JZ      01EE}
/$92                     {XCHG    DX,AX}
/$F7/$F3                 {DIV     BX}
/$8B/$C2                 {MOV     AX,DX}
);

PROCEDURE FillType(Fill : Byte;VAR Arr);
INLINE
($5F                     {POP     DI}
/$07                     {POP     ES}
/$58                     {POP     AX}
/$8A/$E0                 {MOV     AH,AL}
/$FC                     {CLD}
/$AB                     {STOSW}
/$AB                     {STOSW}
/$AB                     {STOSW}
);
IMPLEMENTATION

BEGIN
END.



