UNIT PopGraph;

{$A+,B-,D+,E-,F-,I-,L+,N+,O-,R-,S-,V-,G-}
{$M 16384,0,655360}


INTERFACE

USES Graph,Global,Crt,Linlib,Utility,Math,ScrLib,PrintSc2,
     VGAPal,LaserPr, GraphWin, OwlGraph, graphwin;

CONST
     DataFlag = -7777;
     FirstTime : Boolean = TRUE;
   

TYPE
    IntArray      = Array[1..MaxYears] OF Integer;
    TwoDPtr       = Array[0..9] OF DataPtr;

    TextBuffer    = Array[0..65534] OF Byte;
    BuffPtr       = ^TextBuffer;
    ColorArr      = Array[1..13] OF Byte;
    TitleArr      = Array[1..13] OF String[40];
    CharSet       = Set OF Char;
    Menu = RECORD
                 StartX,StartY         : Byte;
                 BackAtt,TextAtt,HiAtt,
                 N                     : Byte;
                 PosArr                : Array[1..5] OF Byte;
                 StrArr                : Array[1..5] OF String[39];
                 LetterSet             : CharSet;
           END;
VAR
   Pop,Pair,
   PopSD,PairSD,
   IdentByDescentSD,
   IdentByDescent                            : DataPtr;
   OwlTotal, OwlSd                           : TwoDPtr;
   NSize                                     : IntArray;
   Inp                                       : Text;
   EscSw,PrinterOn                           : Boolean;
   Buff                                      : BuffPtr;
   GlobRuns,Years,MinPop,ExtinctNo           : Word;
   MeanExtTime,MeanDeathDist,MeanPairDist    : Single;
   LastStage                                 : Word;


{*************************Graphics}

CONST
     OwlColor : ColorArr   = (LightRed, Yellow,White,LightGray,LightCyan,LightMagenta,
                              LightBlue,LightBlue,LightGreen,Blue,Cyan,Green,White);
   
     OwlTitle : TitleArr   = ('TOTAL','PAIR', 'IDENTICAL BY DESCENT', 'AGE ',
                             'AGE', 'AGE', 'AGE', 'AGE', 'AGE', 'AGE', 'AGE',
                              'AGE', 'AGE');
     OutTitle : TitleArr   = ('POP','PAIR', 'AGE 0', 'AGE 1', 'AGE 2',
                             'AGE 3', 'AGE 4', 'AGE 5', 'AGE 6', 'AGE 7', 'AGE 8',
                             'AGE 9','');
                            
   
    KeyWin  : GraphWindow = (Pt : (Size : 0;Area : NIL);
                            X1 :  245;
                            Y1 :  1;
                            X2 : 420;
                            Y2 : 60;
                            LineWidth  : NormWidth;
                            LineType   : SolidLn;
                            LineColor  : Yellow;
                            InnerColor : Blue;
                            Pattern    : SolidFill);

PROCEDURE InitializeVectors;
PROCEDURE GetMean(VAR Inf : Text; VAR Err : Boolean);
PROCEDURE GetStd(VAR Inf : Text);
PROCEDURE CallGraph(YrCtr : Word);
PROCEDURE CreateAxes(FY, Time                   : Word;
                     VAR XTitle,YTitle          : String;
                     MaxY,ScaleX,ScaleY         : Single;
                     StartX,StartY              : Word);
PROCEDURE DrawGraph(    FY,Time       : Word;
                    VAR YVect         : RealDataArray;
                    XTitle,YTitle     : String;
                        LineOn        : Boolean;
                        Color         : Byte;
                        Style         : Byte;
                    VAR ScaleX,ScaleY : Single;
                    VAR Error         : Boolean);
PROCEDURE PairGraph(Mean,Std : DataPtr;
                    Limits   : Dimension);
IMPLEMENTATION

PROCEDURE ScaleAxes(   FY, N     : Word;
                    VAR Arr      : RealDataArray;
                    VAR IntArr   : IntArray;
                    VAR MaxVal   : Single;
                    VAR ScaleVal : Single;
                    ScaleTo      : Word);
          VAR
             Ct : Word;
          BEGIN
               IF N = 0 THEN Exit;
               MaxVal := Arr[FY];
               FOR Ct := FY TO N DO
                  IF (Arr[Ct] > MaxVal) THEN
                     MaxVal := Arr[Ct];
               IF MaxVal > 0 THEN
                  ScaleVal := ScaleTo/MaxVal
               ELSE
                   ScaleVal := 0;
               RoundAndScaleRow(N,ScaleVal,Arr,IntArr);
               FOR Ct := FY TO N DO
                   IF IntArr[Ct] < 0 THEN
                      IntArr[Ct] := 0;
END;
PROCEDURE DrawHashMarks(PosX,PosY,Number : Word;Vertical : Boolean);
          VAR
             St : String[2];
          BEGIN

               IF Vertical THEN BEGIN
                  Str(Number:2,St);
                  Line(PosX-3,PosY,PosX+3,PosY);
                  OutTextXY(PosX-12,PosY,St);
               END
               ELSE BEGIN
                    Str(Number,St);
                    Line(PosX,PosY + 3,PosX,PosY-3);
                    OutTextXY(PosX,PosY + 12,St);
               END;
END;
PROCEDURE SeparateExponent(N : Single;VAR Mant : Single;VAR Exp : ShortInt);
          VAR
             St : String[30];
             s  : Integer;
          BEGIN
               Str(N,St);
               Exp := Byte(St[Byte(St[0])]); {last letter}
               Dec(Exp,48);
               IF St[Length(St) - 4] = '-' THEN
                  Exp := -Exp;
               Val(Copy(St,1,5),Mant,s);     {3 decimal places}
               IF Mant < 2 THEN BEGIN
                     Dec(Exp);
                     Mant := Mant * 10;
               END;
END;
PROCEDURE CreateAxes(FY, Time                   : Word;
                     VAR XTitle,YTitle          : String;
                     MaxY,ScaleX,ScaleY         : Single;
                     StartX,StartY              : Word);
          VAR
             XLabel,YLabel     : String[9];
             YExponent,
             XExponent         : ShortInt;
             FMantissa,
             XMantissa,
             YMantissa         : Single;
             StopX,StopY       : Integer;
             AxisScaleX,
             AxisScaleY        : Single;
             RoundUpX,RoundUpY : Byte;
             Ct                : Word;
             FYStr             : String;
             StartCt           : Word;
          BEGIN
               YLabel := '';
               SeparateExponent(MaxY,YMantissa,YExponent);
               CASE YExponent OF
                    3 : YLabel := 'x 1000';
                    2 : YLabel := 'x 100';
                    1 : YLabel := 'x 10';
                   -1 : YLabel := 'x 0.1';
                   -2 : YLabel := 'x 0.01';
                   -3 : YLabel := 'x 0.001';
                   -4 : YLabel := 'x 0.0001';
               END;

               XLabel := '';
               SeparateExponent(Time,XMantissa,XExponent);
               CASE XExponent OF
                    3 : XLabel := 'x 1000';
                    2 : XLabel := 'x 100';
                    1 : XLabel := 'x 10';
                   -1 : XLabel := 'x 0.1'
               END;
               FMantissa := FY/XToTheY(10,XExponent);
               AxisScaleX := XToTheY(10,XExponent) * ScaleX;
               AxisScaleY := XToTheY(10,YExponent) * ScaleY;
               RoundUpX := Trunc(XMantissa + 0.5);
               RoundUpY := Trunc(YMantissa + 0.5);
               StopY := StartY - Round(RoundUpY * AxisScaleY);
               IF StopY < 10 THEN BEGIN
                  StopY := 10;
                  Dec(RoundUpY);
               END;
               StopX := StartX + Round(RoundUpX * AxisScaleX);
               IF StopX > GetMaxX THEN BEGIN
                  StopX := GetMaxX - 10;
                  Dec(RoundUpX);
               END;
               SetColor(LightCyan);
               SetLineStyle(0,0,1);
               Line(StartX,StartY,StartX,StopY);
               Line(StartX,StartY,StopX,StartY);
               SetTextJustify(1,1);
             
               Str(FMantissa:4:2,FYStr);
               OutTextXY(StartX, StartY + 12, FYStr);
               StartCt := Round(FMantissa + 0.5);
               DrawHashMarks(StartX + Round((StartCt-FMantissa)*AxisScaleX),StartY,StartCt,FALSE);
               FOR Ct := StartCt + 1 TO RoundUpX DO
                   DrawHashMarks(StartX + Round((Ct-FMantissa) * AxisScaleX),StartY,Ct,FALSE);
               FOR Ct := 1 TO RoundUpY DO
                   DrawHashMarks(StartX,StartY - Round(Ct * AxisScaleY),Ct,TRUE);
               SetColor(White);
               OutTextXY(GetMaxX SHR 1,GetMaxY-10,XTitle + ' ('+ XLabel + ')');
               SetTextStyle(0,1,1);
               OutTextXY(10,GetMaxY SHR 1,YTitle + ' (' + YLabel + ')');
               SetTextStyle(0,0,1);
END;
PROCEDURE WriteRange(Limits : Dimension);

VAR
   R1Str,R2Str,X1Str,X2Str,Y1Str,Y2Str,FYStr,LYStr : String;
BEGIN
   SetTextJustify(0,2);
   OpenGraphWindow(KeyWin);
   WriteGWin(1,1,KeyWin,'Pair Population',Yellow);
   WITH Limits DO BEGIN
     Str(R1,R1Str);
     Str(R2,R2Str);
     Str(FY,FYStr);
     Str(LY,LYStr);
     Str(X1,X1Str);
     Str(X2,X2Str);
     Str(Y1,Y1Str);
     Str(Y2,Y2Str);
   END;
   WriteGWin(1,2,KeyWin, 'Runs ' + R1Str + ' TO ' + R2Str, Yellow);
   WriteGWin(1,3,KeyWin,'Years ' + FYStr + ' TO ' + LYStr,Yellow);
   WriteGWin(1,4,KeyWin,
      '(' +X1Str +','+Y1Str+') TO ('+ X2Str + ',' +Y2Str + ')', yellow);
   WriteGWin(1,5,KeyWin, 'Any Key To Continue', Red);
END;
PROCEDURE GraphLegend(    Start,N  : Byte;
                      VAR Colors   : ColorArr;
                          Styles   : Byte;
                      VAR Titles   : TitleArr);
         VAR
            Ct : Byte;
         BEGIN
              MoveTo(280,10);
              SetTextStyle(0,0,1);
              SetTextJustify(0,1);
              FOR Ct := Start TO Pred(Start + N) DO BEGIN
                  SetColor(LightCyan);
                  OutText(Titles[Ct]);
                  SetColor(Colors[Ct]);
                  SetLineStyle(0,0,Styles);
                  LineTo(GetX + 20,GetY);
              END;
END;
PROCEDURE DrawGraph(    FY,Time       : Word;
                    VAR YVect         : RealDataArray;
                    XTitle,YTitle     : String;
                        LineOn        : Boolean;
                        Color         : Byte;
                        Style         : Byte;
                    VAR ScaleX,ScaleY : Single;
                    VAR Error         : Boolean);
          VAR
             IntYArr   : IntArray;
             GphX,GphY,
             Ct,DistX,
             DistY,
             StartX,StartY    : Word;
             MaxVal           : Single;
          BEGIN
               DistY := Round(0.75 * GetMaxY);
               DistX := Round(0.75 * GetMaxX);
               StartX := Round(GetMaxX * 0.1);
               StartY := Round(GetMaxY * 0.9);
               ScaleAxes(FY, Time,YVect,IntYArr,MaxVal,ScaleY,DistY);
               ScaleX := DistX/(Time- FY);
               Error := ScaleX < 1;
               IF Error THEN
                  Exit;
               CreateAxes(FY,Time,XTitle,YTitle,MaxVal,ScaleX,ScaleY,StartX,StartY);
               SetColor(Color);
               SetLineStyle(0,0,Style);
               MoveTo(StartX,StartY - IntYArr[FY]);
               IF LineOn THEN
                  FOR Ct := 2 TO Time - FY DO
                     LineTo(StartX + Round(Pred(Ct) * ScaleX),StartY - IntYArr[FY +Ct])
               ELSE

                   FOR Ct := 2 TO Time-FY DO
                    PutPixel(StartX + Round(Pred(Ct) * ScaleX),StartY - IntYArr[FY+Ct],White);
END;
PROCEDURE AdditionalLines(    FY, Time      : Word;
                          VAR YVect         : RealDataArray;
                              LineOn        : Boolean;
                              Color         : Byte;
                              Style         : Byte;
                              ScaleX,ScaleY : Single);
          VAR
             IntYArr   : IntArray;
             GphX,GphY,
             Ct,DistX,
             DistY,
             StartX,StartY    : Word;
             MaxVal,Dummy     : Single;
          BEGIN
               DistY := Round(0.75 * GetMaxY);
               StartX := Round(GetMaxX * 0.1);
               StartY := Round(GetMaxY * 0.9);
               RoundAndScaleRow(Time,ScaleY,YVect,IntYArr);
               FOR Ct := 1 TO Time DO
                   IF IntYArr[Ct] < 0 THEN
                      IntYArr[Ct] := 0;
               SetColor(Color);
               SetLineStyle(0,0,Style);
               MoveTo(StartX,StartY - IntYArr[FY]);
               IF LineOn THEN
                  FOR Ct := 2 TO Time-FY DO
                     LineTo(StartX + Round(Pred(Ct) * ScaleX),StartY - IntYArr[FY+Ct])
               ELSE
                   FOR Ct := 2 TO Time-FY DO
                    PutPixel(StartX + Round(Pred(Ct) * ScaleX),StartY - IntYArr[FY+Ct],White);
END;

PROCEDURE GraphOwlData(OwlClass , SD : DataPtr; ColorNum : Byte;
                               Limits : Dimension;
                               Range : Boolean);
VAR
    Data    : RealDataArray;
    ScaleY,ScaleX     : Single;
    Err               : Boolean;

BEGIN
    MoveRow(OwlClass^,Data,Limits.LY);
    AddRows(Limits.LY,Data,SD^);
    IF Range THEN WriteRange(Limits)
    ELSE
        GraphLegend(ColorNum,1,OwlColor,3,OwlTitle);
    DrawGraph(Limits.FY,Limits.Ly,Data,'TIME IN YEARS','POPULATION',
           TRUE,OwlColor[ColorNum],1,ScaleX,ScaleY,Err);
    AdditionalLines(Limits.FY,Limits.LY,OwlClass^,TRUE,OwlColor[ColorNum],3,ScaleX,ScaleY);
    MoveRow(OwlClass^,Data,Limits.Ly);
    SubRows(Limits.Ly,Data,SD^);
    AdditionalLines(Limits.FY,Limits.LY,Data,TRUE,OwlColor[ColorNum],1,ScaleX,ScaleY);
END;

PROCEDURE CallGraph(YrCtr : Word);
          VAR
             Ct                : Word;
             Ch,Ch2            : Char;
             chk               : Integer;
             Limits            : Dimension;
VAR
   Err     : Boolean;
   LoopCtr : Byte;
   OwlAge  : String[3];
LABEL
     LOOP;
BEGIN
   SetFillStyle(0,0);
   Bar(0,0,GetmaxX, GetMaxY);
   LoopCtr := 0;
   Limits.FY := 1;
   Limits.Ly := YrCtr;
   REPEAT
      CASE LoopCtr OF
           0 : BEGIN
                   GraphOwlData(Pop,PopSD,1,Limits,FALSE);
               END;
           1 : BEGIN
                  GraphOwlData(Pair,PairSD,2,Limits,FALSE);
               END;
           2 : BEGIN
                  GraphOwlData(IdentByDescent,IdentByDescentSD,3,Limits,FALSE);
               END;
           ELSE
               BEGIN
                  Str(LoopCtr-3, OwlAge);
                  OwlTitle[LoopCtr+1] := Concat('Age ', OwlAge);
                  GraphOwlData(OwlTotal[LoopCtr-3],OwlSD[LoopCtr-3],LoopCtr+1,Limits,FALSE);
               END;
      END;
               GetKeys(Ch,Ch2);
               case ch2 of
                    #25 : PrintScreen(FALSE,Device,Err);
                    #38 : PrintScreen(TRUE,Device,Err);
                    #31 : LaserPrintScreen(Device,Err);
                    #17 : LaserLandscapePrintScreen(Device,Err);
                    ELSE BEGIN
                         LoopCtr := Succ(LoopCtr) MOD (4 + LastStage);
                         ClearDevice;
                    END;
               end;
  UNTIL Ch = #27;
  SettextJustify(0,2);
END;
PROCEDURE PairGraph(Mean,Std : DataPtr;
                     Limits  : Dimension);
         
          VAR
             Ct                : Word;
             Ch,Ch2            : Char;
             Err     : Boolean;
             OwlAge  : String[3];

BEGIN
      SetFillStyle(0,0);
      Bar(0,0,GetmaxX, GetMaxY);
      if Device = 9 then
         ChangePalette(Normal);
       GraphOwlData(Mean,Std,2, Limits,TRUE);
       Repeat
          GetKeys(Ch, Ch2);
       Until (Ch <> #0);
       SetTextJustify(0,2);
       RestoreGraphWindow(KeyWin);
       CLearDevice;
END;


{**************************************File Input and data manipulation}


PROCEDURE Wait;
          BEGIN
               Clrscr;
               FastWrite(148,79 + Blink,' WAIT ');
END;

FUNCTION CheckFile(VAR Inf : Text) : Boolean;
          VAR
             x : Integer;
           
          BEGIN
               ReadLn(Inf,x);
               Checkfile := (x = DataFlag);
END;

PROCEDURE InitializeVectors;
CONST
   FirstTime : Boolean = TRUE;

VAR
   i :Integer;

          BEGIN
               IF FirstTime THEN  BEGIN
                New(Pop);
                   FOR i := 0 TO MaxStages DO  BEGIN
                         New(OwlTotal[i]);
                         New(OwlSD[i]);
                   END;
                New(Pair);             
                New(IdentByDescent);
                New(PopSD);             
                New(PairSD);             
                New(IdentByDescentSD);
               END;
               FOR i := 0 TO MaxStages DO BEGIN
                ZeroFill(OwlTotal[i]^,SizeOf(RealDataArray));
                ZeroFill(OwlSD[i]^, SizeOf(RealDataArray));
               END;
               ZeroFill(Pop^,SizeOf(RealDataArray));
               ZeroFill(Pair^,SizeOf(RealDataArray));
               ZeroFill(IdentByDescent^,SizeOf(RealDataArray));
               ZeroFill(PopSD^,SizeOf(RealDataArray));             
               ZeroFill(PairSD^,SizeOf(RealDataArray));
               ZeroFill(IdentByDescentSD^,SizeOf(RealDataArray));
               ZeroFill(NSize,SizeOf(NSize));
               FirstTime := FALSE;
END;
PROCEDURE GetMean(VAR Inf : Text; VAR Err : Boolean);
          VAR
             Ct1,Ct2,Runs          : Word;
             Yr,p,t,i,OwlCt        : Word;
             Ma,Ibd                : Single;
             Temp                  : Extended;
             Flag                  : Integer;

          BEGIN
               Err := FALSE;
               ReadLn(Inf, Flag);
               IF (Flag <> DataFlag) THEN  BEGIN
                  MenuInputErrors(1,1,5);
                  Err := TRUE;
               END
               ELSE BEGIN
               ReadLn(Inf,Runs,Years, LastStage);
               GlobRuns := Runs;
               IF Years > MaxYears THEN BEGIN
                  WriteLn('Data size too large');
                  Close(Inf);
                  Halt;
               END;
               FOR Ct1 := 1 TO Runs DO BEGIN
                   FOR Ct2 := 1 TO Years DO BEGIN
                       Read(Inf,Yr);
                       FOR i := 0 TO LastStage DO BEGIN
                          Read(Inf, OwlCt);
                          OwlTotal[i]^[Ct2] := OwlTotal[i]^[Ct2] +OwlCt;
                       END;
                       Read(Inf, p);
                       Pair^[Ct2] := Pair^[Ct2] + p;
                       Read(Inf, t);
                       Pop^[Ct2]  := Pop^[Ct2] + t;
                       ReadLn(Inf, Ibd);
                       IdentByDescent^[Ct2] := IdentByDescent^[Ct2] + Ibd;
                   END;
                END;
                Temp := 1/Runs;
                FOR i := 0 TO LastStage DO
                   MulConst(Years,Temp,OwlTotal[i]^);
                MulConst(Years,Temp,Pair^);
                MulConst(Years,Temp,Pop^);
                MulConst(Years,Temp,IdentByDescent^);
             END;

END;
PROCEDURE VectSqrt(N : Word; VAR Vect : RealDataArray);
          VAR
             Ct : Word;
          BEGIN
               FOR Ct := 1 TO N DO
                   Vect[Ct] := Sqrt(Vect[Ct]);
END;
PROCEDURE GetStd(VAR Inf : Text);
          VAR
             Ct1,Ct2,Runs,Years,i  : Word;
             Yr,p,t,OwlCt          : Word;
             Flag                  : Integer;
             Ma,Ibd                : Single;
             Temp                  : Extended;
            
          BEGIN
               ReSet(Inf);
               ReadLn(Inf,Flag);
               ReadLn(Inf,Runs,Years, LastStage);
               FOR Ct1 := 1 TO Runs DO BEGIN
                   FOR Ct2 := 1 TO Years DO BEGIN
                       Read(Inf,Yr);
                       FOR i := 0 TO LastStage DO BEGIN
                          Read(Inf, OwlCt);
                          OwlSD[i]^[ct2] := OwlSD[i]^[ct2] + Sqr(OwlTotal[i]^[ct2]-OwlCt);
                       END;
                       ReadLn(Inf, p,t,ibd);
                       PairSD^[Ct2] := PairSD^[Ct2] + Sqr(Pair^[Ct2] - p);
                       PopSD^[Ct2]  := PopSD^[Ct2] + Sqr(Pop^[Ct2] - t);                     
                       IdentByDescentSD^[Ct2] := IdentByDescentSD^[Ct2] +
                                                 Sqr(IdentByDescent^[Ct2]-Ibd);
                   END;
                END;
                Close(Inf);
                Temp := 1/Pred(Runs);
                FOR i := 0 TO LastStage DO BEGIN
                    MulConst(Years,Temp,OwlSD[i]^);
                    VectSqrt(Years,OwlSD[i]^);
                END;
                MulConst(Years,Temp,PairSD^);
                MulConst(Years,Temp,PopSD^);
                MulConst(Years,Temp,IdentByDescentSD^);               
                VectSqrt(Years,PairSD^);
                VectSqrt(Years,PopSD^);
                VectSqrt(Years,IdentByDescentSD^);
END;

{**************************************Program IO}

CONST
    OutRed : Menu = (StartX   : 33;
                     StartY   : 11;
                     BackAtt  : 7;
                     TextAtt  : 7;
                     HiAtt    : 15;
                     N        : 5;
                     PosArr   : (11,11,1,1,1);
                     StrArr   : ('output to File',
                                 'output to Printer',
                                 'Graphic output','Mean occupancy',
                                 'Summary statistics');
                     LetterSet : ['F','P','G','M','S',#27]);

FUNCTION ReturnLetter(Chrs : CharSet) : Char;
         VAR
            Ch,Ch2 : Char;
         BEGIN
              REPEAT
                    GetKeys(Ch,Ch2);
                    Ch := Upcase(Ch);
              UNTIL Ch IN Chrs;
              ReturnLetter := Ch;
END;


{***********************************Main Program}


BEGIN
    
END.

